=== docs/mkdocs/requirements.txt ===
Babel==2.13.1
certifi==2023.7.22
charset-normalizer==3.3.1
click==8.1.7
csscompressor==0.9.5
future==0.18.3
ghp-import==2.1.0
gitdb==4.0.11
GitPython==3.1.40
htmlmin==0.1.12
httplib2==0.22.0
idna==3.4
importlib-metadata==6.8.0
Jinja2==3.1.2
joblib==1.3.2
jsmin==3.0.1
livereload==2.6.3
lunr==0.7.0.post1
Markdown==3.5
markdown-include==0.8.1
MarkupSafe==2.1.3
mergedeep==1.3.4
mkdocs==1.5.3
mkdocs-git-revision-date-localized-plugin==1.2.1
mkdocs-material==9.4.7
mkdocs-material-extensions==1.3
mkdocs-minify-plugin==0.7.1
mkdocs-redirects==1.2.1
mkdocs-simple-hooks==0.1.5
nltk==3.8.1
packaging==23.2
plantuml==0.3.0
plantuml-markdown==3.9.2
Pygments==2.16.1
pymdown-extensions==10.3.1
pyparsing==3.1.1
python-dateutil==2.8.2
pytz==2023.3.post1
PyYAML==6.0.1
pyyaml_env_tag==0.1
regex==2023.10.3
requests==2.31.0
six==1.16.0
smmap==5.0.1
tornado==6.3.3
tqdm==4.66.1
urllib3==2.0.7
watchdog==3.0.0
zipp==3.17.0
