=== debian/changelog ===
nlohmann-json3 (3.12.0.really.3.12.0.really.3.11.3-3) unstable; urgency=medium

  * Fix with -DJSON_TestDataDirectory=/usr/share/json_test_data
    instead of JSON_No_Internet
  * Drop patch 4851.patch

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 25 Oct 2025 09:39:19 +0200

nlohmann-json3 (3.12.0.really.3.12.0.really.3.11.3-2) unstable; urgency=medium

  * Forgot to set JSON_No_Internet to tests too, fixing autopkgtests

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 29 Sep 2025 20:55:40 +0200

nlohmann-json3 (3.12.0.really.3.12.0.really.3.11.3-1) unstable; urgency=medium

  * Add patch to use new json-test-data package to have full testsuite running
  * Revert the ABI changes, we will separate source package into new sources
    on earch upstream release

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 25 Sep 2025 09:54:47 +0200

nlohmann-json3 (3.12.0-3) unstable; urgency=medium

  * Implement new nlohmann-json3-abi-@VER@ to make sure
    reverse-dependencies gets rebuilt on new release
    (See: #1110784, #1110787, #1110805)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 15 Sep 2025 09:56:54 +0200
