=== debian/control ===
Source: nlohmann-json3
Priority: optional
Maintainer: Hubert Chathi <uhoreg@debian.org>
Build-Depends:
 cmake,
 debhelper-compat ( = 13),
 json-test-data,
 doxygen,
 ghostscript,
 graphviz,
 texlive-binaries,
 texlive-latex-base,
Standards-Version: 4.7.2
Rules-Requires-Root: no
Section: libs
Homepage: https://nlohmann.github.io/json/
Vcs-Git: https://salsa.debian.org/debian/nlohmann-json3.git
Vcs-Browser: https://salsa.debian.org/debian/nlohmann-json3

Package: nlohmann-json3-dev
Section: libdevel
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Conflicts:
 nlohmann-json-dev
Description: JSON for Modern C++
 JSON library with intuitive syntax, trivial integration and serious
 testing. Other aspects, as memory efficiency and speed were not so
 important. The library consists of a single source file json.hpp.
