=== debian/tests/control ===
Tests: cmake-test
Depends: ca-certificates, git, @builddeps@
Restrictions: allow-stderr
