=== debian/changelog ===
nlohmann-json3 (3.12.0.really.3.12.0.really.3.12.0-2) experimental; urgency=medium

  * Merge with 3.12.0.really.3.12.0.really.3.11.3-2

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 29 Sep 2025 20:57:39 +0200

nlohmann-json3 (3.12.0.really.3.12.0.really.3.12.0-1) experimental; urgency=medium

  * Use the new json-test-data package
  * 3.12 for now is intended for experimental only

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 29 Sep 2025 11:00:04 +0200

nlohmann-json3 (3.12.0.really.3.12.0-4) UNRELEASED; urgency=medium

  * Add patch to use new json-test-data package to have full testsuite running
  * Revert the ABI changes, we will separate source package into new sources
    on earch upstream release

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 25 Sep 2025 09:54:47 +0200
